import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { CnBuildTool } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2021-11-03 17:17
 */
interface CnBuildToolCU extends ConditionUtil<CnBuildToolCU>{
    ID:FieldUtil<CnBuildToolCU>;
    NAME:FieldUtil<CnBuildToolCU>;
    VERSION:FieldUtil<CnBuildToolCU>;
    DELETED:FieldUtil<CnBuildToolCU>;
    CREATE_USER_ID:FieldUtil<CnBuildToolCU>;
    CREATE_TIME:FieldUtil<CnBuildToolCU>;
    UPDATE_USER_ID:FieldUtil<CnBuildToolCU>;
    UPDATE_TIME:FieldUtil<CnBuildToolCU>;
}

class CnBuildToolCUImpl extends ConditionUtilImpl<CnBuildToolCUImpl> implements CnBuildToolCU{ 
    newInstance(): CnBuildToolCUImpl {
        return new CnBuildToolCUImpl();
    } 
    get ID(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('id','id','id', this);
    }
    get NAME(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('name','name','名称：maven、gradle、nodejs、go', this);
    }
    get VERSION(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('version','version','版本号：3.6.5、2.6、14、...', this);
    }
    get DELETED(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('deleted','deleted','deleted', this);
    }
    get CREATE_USER_ID(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('create_user_id','createUserId','create_user_id', this);
    }
    get CREATE_TIME(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('create_time','createTime','create_time', this);
    }
    get UPDATE_USER_ID(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('update_user_id','updateUserId','update_user_id', this);
    }
    get UPDATE_TIME(): FieldUtil<CnBuildToolCU>{  
        return new FieldUtil('update_time','updateTime','update_time', this);
    }
}

@Singleton 
class CnBuildToolMU extends TableUtilImpl<CnBuildToolCU,CnBuildTool>{ 
    tableName  = 'cn_build_tool';
    tableFields  = ['id','name','version','deleted','create_user_id','create_time','update_user_id','update_time'];
    modelFields  = ['id','name','version','deleted','createUserId','createTime','updateUserId','updateTime'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): CnBuildToolCU {
        return new CnBuildToolCUImpl();
    }   

    static get ID(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('id','id','id', new CnBuildToolCUImpl());
    }
    static get NAME(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('name','name','名称：maven、gradle、nodejs、go', new CnBuildToolCUImpl());
    }
    static get VERSION(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('version','version','版本号：3.6.5、2.6、14、...', new CnBuildToolCUImpl());
    }
    static get DELETED(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('deleted','deleted','deleted', new CnBuildToolCUImpl());
    }
    static get CREATE_USER_ID(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('create_user_id','createUserId','create_user_id', new CnBuildToolCUImpl());
    }
    static get CREATE_TIME(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('create_time','createTime','create_time', new CnBuildToolCUImpl());
    }
    static get UPDATE_USER_ID(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('update_user_id','updateUserId','update_user_id', new CnBuildToolCUImpl());
    }
    static get UPDATE_TIME(): FieldUtil<CnBuildToolCU>{ 
        return new FieldUtil('update_time','updateTime','update_time', new CnBuildToolCUImpl());
    }

    get ID(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.ID;
    }
    get NAME(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.NAME;
    }
    get VERSION(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.VERSION;
    }
    get DELETED(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.DELETED;
    }
    get CREATE_USER_ID(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.CREATE_USER_ID;
    }
    get CREATE_TIME(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.CREATE_TIME;
    }
    get UPDATE_USER_ID(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.UPDATE_USER_ID;
    }
    get UPDATE_TIME(): FieldUtil<CnBuildToolCU>{ 
        return CnBuildToolMU.UPDATE_TIME;
    }
}
export {CnBuildToolMU, CnBuildToolCU}
